/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 13-8-2002
 * Description : qlabeldrag
 *
 * Copyright 2002-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#ifndef QLABELDRAG_H
#define QLABELDRAG_H

#include<qlabel.h>
class QDragEnterEvent;
class QDragMoveEvent;

class  LabelDrag : public QLabel
{
    Q_OBJECT
  public:
    LabelDrag ( QWidget * parent = 0, Qt::WindowFlags f = 0 );
    // Low-level drag and drop
    void dragEnterEvent ( QDragEnterEvent *evt );
    virtual void dropEvent ( QDropEvent *evt );
    void mousePressEvent ( QMouseEvent *evt );
    /* void mouseMoveEvent( QMouseEvent * );*/
    void setDragging ( bool drag );
    void setChangeText ( bool );
  private:

    bool _drag;
    bool _changeText;
  signals:
    void dropReceived ( QLabel *source, QLabel *destination );
};

#endif //QLABELDRAG_H
