/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 13-8-2002
 * Description : Difficolta' ortografiche implementation
 *
 * Copyright 2002-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#ifndef WINDOWAGGETTIVI_H
#define WINDOWAGGETTIVI_H

#include <QtGui/QMainWindow>
#include <QLabel>
#include "accoppiamenti.h"

namespace Ui
{
    class WindowAggettivi;
}

class WindowAggettivi : public QMainWindow
{
    Q_OBJECT

public:
    WindowAggettivi(QWidget *parent = 0);
    ~WindowAggettivi();

private:
  Ui::WindowAggettivi *ui;
  int indovinati;
  accoppiamenti *coppie;
  /*!
  * Load saved setting (or default)
  */
  void loadSetting();

  /*!
   * Set graphics setting
   */
  void saveSettings();

public slots:
    void info();
    void avanti();
    void azzera();
    void actionDrop(QLabel*,QLabel*);
    void esci() {close();}
};

#endif // WINDOWAGGETTIVI_H
