/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 20-8-2002
 * Description : Scegli Aggettivo implementation
 *
 * Copyright 2002-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#include "scegliagg.h"

#include <qvariant.h>
#include <qlabel.h>
#include <qlcdnumber.h>
#include <qpushbutton.h>
#include <qmime.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <QMessageBox>
#include "aboutdlg.h"
#include "scegliaggettivo_version.h"

ScegliAggettivoDialog::ScegliAggettivoDialog( QWidget* parent) : QDialog(parent), Ui_Form1(),coppie(NULL)
{
  setupUi(this);
  layout()->setMargin ( 0 );
  QString title = QString(APPL_NAME)    + " V. " +
            QString(APPL_VERSION) + " ";
  setWindowIcon(QIcon( QPixmap(QString(RESOURCE_DIR) + "/educazionik.png")));
  setWindowTitle(title);
  // signals and slots connections
  connect( m_go_on, SIGNAL( pressed() ), this, SLOT( avanti() ) );
  connect( m_info, SIGNAL( pressed() ), this, SLOT( info() ) );
  connect( m_exit, SIGNAL( pressed() ), this, SLOT( esci() ) );
  connect( m_resetButton, SIGNAL( pressed() ), this, SLOT( azzera() ) );
  connect(TextLabel8, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
  connect(TextLabel9, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
  connect(TextLabel10, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
  connect(TextLabel11, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
  connect(TextLabel12, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
  connect(TextLabel13, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
  connect(TextLabel14, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
  TextLabel1->setDragging(true);
  TextLabel2->setDragging(true);
  TextLabel3->setDragging(true);
  TextLabel4->setDragging(true);
  TextLabel5->setDragging(true);
  TextLabel6->setDragging(true);
  TextLabel7->setDragging(true);
  
  init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
ScegliAggettivoDialog::~ScegliAggettivoDialog()
{
    delete coppie;
}


void ScegliAggettivoDialog::init()
{
    int i,pos;
    QString a[7],b[7];
    coppie = new parolaFrase(QString(DATA_DIR) + "/scegliaggettivo.txt",7);

    if (coppie->errorValue()!=-1)
    {
      avanti();
    }
    else
    {
        TextLabel1->hide();
        TextLabel2->hide();
        TextLabel3->hide();
        TextLabel4->hide();
        TextLabel5->hide();
        TextLabel6->hide();
        TextLabel7->hide();
        TextLabel8->hide();
        TextLabel9->hide();
        TextLabel10->hide();
        TextLabel11->hide();
        TextLabel12->hide();
        TextLabel13->hide();
        TextLabel14->hide();
        m_go_on->hide();
        m_resetButton->hide();
        LCD_Correct->hide();
        LCD_Wrong->hide();
         
        QString title     = QString(APPL_NAME) + " V. " + QString(APPL_VERSION);
        QMessageBox::critical( 0, title, QString("Non riesco a trovare il file " + QString(DATA_DIR) + "/scegliaggettivo.txt "));
    }


}

void ScegliAggettivoDialog::action_drop(QLabel *a, QLabel *b)
{
    QString dum;
    int pos;

    dum=b->text();
    pos=dum.indexOf("\n");
    if (pos!=-1)
        dum.replace(pos,1," ");

    if ((coppie->esatto(dum,a->text()))>-1)
    {
        pos=dum.indexOf("_");
        dum=dum.replace(pos,5,a->text());
        if (dum.length()>50)
        {
            pos=dum.lastIndexOf(" ",(40-dum.length()));
            dum.replace(pos,1,"\n");
        }
        b->setText(dum);
        LCD_Correct->display(LCD_Correct->intValue()+1);
        m_icon->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/smile.png"));
        if (++indovinati ==7)
            m_go_on->setEnabled(true);
        a->setEnabled(false);
        b->setEnabled(false);
    }
    else
    {
        LCD_Wrong->display(LCD_Wrong->intValue()+1);
        m_icon->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/frown.png"));
    }

}

void ScegliAggettivoDialog::avanti()
{
    QString a[7],b[7];
    int i,pos;

    coppie->frase(&b[0],&a[0]);

    for (i=0;i<7;i++)
    {
        if (b[i].length()>50)
        {
            pos=b[i].lastIndexOf(" ",(40-b[i].length()));
            b[i].replace(pos,1,"\n");
        }
    }

    TextLabel1->setText(a[0]);
    TextLabel2->setText(a[1]);
    TextLabel3->setText(a[2]);
    TextLabel4->setText(a[3]);
    TextLabel5->setText(a[4]);
    TextLabel6->setText(a[5]);
    TextLabel7->setText(a[6]);

    TextLabel8->setText(b[0]);
    TextLabel9->setText(b[1]);
    TextLabel10->setText(b[2]);
    TextLabel11->setText(b[3]);
    TextLabel12->setText(b[4]);
    TextLabel13->setText(b[5]);
    TextLabel14->setText(b[6]);

    TextLabel1->setEnabled(true);
    TextLabel2->setEnabled(true);
    TextLabel3->setEnabled(true);
    TextLabel4->setEnabled(true);
    TextLabel5->setEnabled(true);
    TextLabel6->setEnabled(true);
    TextLabel7->setEnabled(true);
    TextLabel8->setEnabled(true);
    TextLabel9->setEnabled(true);
    TextLabel10->setEnabled(true);
    TextLabel11->setEnabled(true);
    TextLabel12->setEnabled(true);
    TextLabel13->setEnabled(true);
    TextLabel14->setEnabled(true);

    m_go_on->setEnabled(false);
    m_icon->clear();

    indovinati=0;

}

void ScegliAggettivoDialog::azzera()
{
    LCD_Wrong->display(0);
    LCD_Correct->display(0);
    avanti();
}

void ScegliAggettivoDialog::info()
{
  QString title     = QString(APPL_NAME) + " V. " + QString(APPL_VERSION);
  QString info = "(c) 2003 <b>Nicola De Filippo</b> - nicola@nicoladefilippo.it<br>"
                 "(c) 2009 <b>Angelo Naselli</b>    - anaselli@linux.it<br>";
  info += "http://educazionik.sourceforge.net";
  QString description = "Programma di esercizi per l'abbinamento degli aggettivi";
  QString icon = QString(RESOURCE_DIR) + "/logo.png";

  //AboutDialog about(this, title, info, description, icon);
  AboutDialog about(this, title, "", description, icon, "", "", "");
  about.exec();
}

void ScegliAggettivoDialog::esci()
{
    QApplication::exit();
}
